<?php
/*******************************************************
Trovate questo e altri script su http://www.manuelmarangoni.it , descritti e commentati nei dettagli.

Autore: Manuel Marangoni
Data messa online dello script: 30 ottobre 2011

Attraverso la classe PHPExcel, lo script mostra come scaricare le immagini presenti in un file (Excel) di tipo xls o xlsx.
La classe PHPExcel è disponibile all'indirizzo http://phpexcel.codeplex.com/
*******************************************************/

include("phpexcel/Classes/PHPExcel.php"); //inclusione della classe
error_reporting(E_ALL); //visualizzazione degli errori attiva, utile per il controllo dei bug

$reader = new PHPExcel_Reader_Excel2007(); //creiamo l'oggetto, valido per file di Excel 2007

$PHPExcel = $reader->load('index.xlsx');
$worksheet = $PHPExcel->getActiveSheet();

// estrae le immagini e le salva
foreach ($worksheet->getDrawingCollection() as $i => $drawing) {
    $filename = $drawing->getPath();
    $imagesize = getimagesize($filename);

    switch($imagesize[2]){

		case 1:
			$image = imagecreatefromgif($filename);
			imagegif($image, "$i.gif");
			break;

		case 2:
			$image = imagecreatefromjpeg($filename);
			imagejpeg($image, "$i.jpeg");
			break; 

		case 3:
			$image = imagecreatefrompng($filename);
			imagepng($image, "$i.png");
			break;

		default:
			continue 2;

    }
	echo $drawing->getCoordinates()."<br /><br />";
}


/*****************
Questa parte viene utile nel caso in cui il vostro file Excel sia più vecchio della versione 2007 oppure sia stato creato con versioni di Calc di Open Office o altri programmi gratuiti. Potete convertire il vostro file in formato Excel2007, attraverso questo script (da richiamare prima di quello soprastante e in una pagina php a parte)
*****************/

include("phpexcel/Classes/PHPExcel.php"); //inclusione della classe
error_reporting(E_ALL); //visualizzazione degli errori attiva, utile per il controllo dei bug
set_time_limit(0); //necessario per creare l'excel, in caso di tempi di attesa troppo lunghi

$objPHPExcel = new PHPExcel();

// legge da Excel5 (.xls)
$objReader = PHPExcel_IOFactory::createReader('Excel5');
$objPHPExcel = $objReader->load("nomefile.xls");

// esporta in Excel2007 (.xlsx)
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter->save(str_replace('.php', '.xlsx', __FILE__));

// esporta in Excel5 (.xls)
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
$objWriter->save(str_replace('.php', '.xls', __FILE__));
